#!/usr/bin/perl -w
use strict;

unless ( $ARGV[0] and $ARGV[0] !~ /-[h?]/ ) {
	print "------------------------------------------------------\n";
	print "|\n|     AMAI Strategy Extractor\n";
	print "|\n|                 by AIAndy\n";
	print "|\n|     Extracts a strategy from AMAI\n";
	print "|\n|     Usage:";		
	print "\n|        perl $0 version race strategy_name > destinationfile\n";		
	print "|\n|     Example:";		
	print "\n|        perl $0 TFT Elf NormalElf > NormalElf.as";		
	print "\n|        perl $0 ROC Human MyStrategy > my_strategy.as";		
	print "\n------------------------------------------------------\n";
	exit;
}

my $version = $ARGV[0];
my $race = $ARGV[1];
my $stratname = $ARGV[2];

open(AIFILE, "$version\\$race\\BuildSequence.ai") or die "File <$version\\$race\\BuildSequence.ai> not found!";
open(STRATFILE, "$version\\$race\\Strategy.txt") or die "File <$version\\$race\\Strategy.txt> not found!";
print "#AMAI 2.0 Strategy\n";
my $line = <STRATFILE>;
while (($line = (<STRATFILE> or die "Strategy not found in Strategy Table")) !~ /^$stratname\t/) {}
print $line;
while (($line = (<AIFILE> or die "Strategy not found in Build Sequence")) !~ /function\s*init_strategy_$stratname/) {}
print $line;
while (($line = (<AIFILE> or die "Strategy not complete in Build Sequence")) !~ /endfunction/) {print $line;}
print $line;
while (($line = (<AIFILE> or die "Strategy not complete in Build Sequence")) !~ /endfunction/) {print $line;}
print $line;