#!/usr/bin/perl -w
use strict;

unless ( $ARGV[0] and $ARGV[0] !~ /-[h?]/ ) {
	print "------------------------------------------------------\n";
	print "|\n|     AMAI Strategy Inserter\n";
	print "|\n|                 by AIAndy\n";
	print "|\n|     Inserts the passed strategy into AMAI\n";
	print "|\n|     Usage:";		
	print "\n|        perl $0 Sourcefile version race\n";		
	print "|\n|     Example:";		
	print "\n|        perl $0 NormalElf.as TFT Elf";		
	print "\n|        perl $0 my_strategy.as ROC Human";		
	print "\n------------------------------------------------------\n";
	exit;
}

my $version = $ARGV[1];
my $race = $ARGV[2];
my $source = $ARGV[0];

open(SOURCE, $source) or die "File <$source> not found!";
open(AIFILE, ">>$version\\$race\\BuildSequence.ai") or die "File <$version\\$race\\BuildSequence.ai> not found!";
open(STRATFILE, ">>$version\\$race\\Strategy.txt") or die "File <$version\\$race\\Strategy.txt> not found!";
my $line = <SOURCE>;
if ($line !~ /#AMAI 2.0 Strategy/) {die "No AMAI 2.0 Strategy File";}
$line = <SOURCE>;
print STRATFILE $line;
print AIFILE "\n";
print AIFILE <SOURCE>;