#!/usr/bin/perl -w
use strict;

unless ( $ARGV[0] and $ARGV[0] !~ /-[h?]/ ) {
	print "------------------------------------------------------\n";
	print "|\n|     AMAI Strategy Remover\n";
	print "|\n|                 by AIAndy\n";
	print "|\n|     Deletes a strategy in AMAI\n";
	print "|\n|     Usage:";		
	print "\n|        perl $0 version race strategy_name\n";		
	print "|\n|     Example:";		
	print "\n|        perl $0 TFT Elf NormalElf";		
	print "\n|        perl $0 ROC Human MyStrategy";		
	print "\n------------------------------------------------------\n";
	exit;
}

my $version = $ARGV[0];
my $race = $ARGV[1];
my $stratname = $ARGV[2];

open(STRATFILE, "$version\\$race\\Strategy.txt") or die "File <$version\\$race\\Strategy.txt> not found!";
my @stratfile = ();
while (<STRATFILE>) {
  unless (/^$stratname\t/) {
    push(@stratfile, $_);
  }
}
close(STRATFILE);
open(STRATFILE, ">$version\\$race\\Strategy.txt") or die "File <$version\\$race\\Strategy.txt> could not be opened for writing!";
print STRATFILE @stratfile;
close(STRATFILE);
@stratfile = ();
open(AIFILE, "$version\\$race\\BuildSequence.ai") or die "File <$version\\$race\\BuildSequence.ai> not found!";
my @aifile = ();
while (<AIFILE>) {
  if (/function\s*init_strategy_$stratname/) {
    while ((<AIFILE> or die "Strategy not complete in Build Sequence") !~ /endfunction/) {}
    while ((<AIFILE> or die "Strategy not complete in Build Sequence") !~ /endfunction/) {}
  }
  else {
    push(@aifile, $_);
  }
}
close(AIFILE);
open(AIFILE, ">$version\\$race\\BuildSequence.ai") or die "File <$version\\$race\\BuildSequence.ai> could not be opened for writing!";
print AIFILE @aifile;
close(AIFILE);
