#!/usr/bin/perl -w
use strict;

unless ( $ARGV[0] and $ARGV[0] !~ /-[h?]/ ) {
	print "------------------------------------------------------\n";
	print "|\n|     Jass Pre-parser version 0.0.11\n";
	print "|\n|                 by Vidstige\n";
	print "|\n|       see http://www.wc3campaigns.com/forums/showthread.php?s=&threadid=38726\n";
	print "|\n|     Usage:";		
	print "\n|        $0 sourcefile [> destinationfile]\n";		
	print "|\n|     Example:";		
	print "\n|        $0 extended_script.eai > script.ai";		
	print "\n|        $0 extended_script.eai\n";		
	print "|\n|     Supported Directives:";		
	print "\n|        #DEFINE var";		
	print "\n|        #UNDEF var";		
	print "\n|        #IFDEF var";		
	print "\n|        #IFNDEF var";		
	print "\n|        #ELSE";		
	print "\n|        #ENDIF";		
	print "\n|        #INCLUDE <filename>";		
	print "\n|        #INCLUDETABLE <filename> #COND %1 eq \"humans\"   // eq == equals";		
	print "\n|        #INCLUDETABLE <filename> #COND %1 ne \"monster\"  // ne == not equals";		
	print "\n|             // %ROW == line number in table file (counting all lines)";
	print "\n|             set MyArray[%ROW] = %1";
	print "\n|             // %row == line number in table file (counting included lines)";
	print "\n|             set MyOtherArray[%row + 5] = %2  ";          
	print "\n|        #ENDINCLUDE\n";
	print "|\n|     Syntactic Shortcuts (some of them...):";		
	print "\n|        i=42 -> set i = 42";	
	print "\n|        i++ -> set i = i + 1";	
	print "\n|        i+=42 -> set i = i + 42";		
	print "\n|        Sleep(2) -> call Sleep(2)";		
	print "\n------------------------------------------------------\n";
	exit;
}

my $tab = "\t";
my $level = 0;
my @file;
my %defs;
my $skip = "";
my %vdefs;

foreach (@ARGV[1..$#ARGV]) {
  $defs{$_} = 1;
}

$file[$level]{"if"} = "#IFNDEF";
$file[$level]{"then"} = 1;
$file[$level]{"else"} = "";
$file[$level]{"now"} = "then";
$file[$level]{"skip"} = "";

open(INFILE, $ARGV[0]) or die "File <$ARGV[0]> not found!";

#warn "$level <$skip> " . $file[$level]{"if"} . " " . $file[$level]{"now"} . " :";
while (<INFILE>) {
	$_ = fnamerep($_) unless /\#DEFINE/;
	if (/^\/\//) {}
	elsif (/(#IFDEF) (\w+)/) {
		#warn "IFDEF";
		$level++;
		$file[$level]{"if"} = $1;
		$file[$level]{"then"} = $defs{$2};  
		#warn "$2:<$defs{$2}>";
		$file[$level]{"else"} = not $defs{$2};  
		#warn ("not $2:<" . (not $defs{$2}) . ">");
		$file[$level]{"now"} = "then";
		$file[$level]{"skip"} = $skip;
		$skip = (not $file[$level]{$file[$level]{"now"}} or $file[$level]{"skip"});
	}
	elsif (/(#IFNDEF) (\w+)/) {
		#warn "IFNDEF";
		$level++;
		$file[$level]{"if"} = $1;
		$file[$level]{"then"} = not $defs{$2};  
		#warn "$2:<$defs{$2}>";
		$file[$level]{"else"} = $defs{$2};  
		#warn ("not $2:<" . (not $defs{$2}) . ">");
		$file[$level]{"now"} = "then";
		$file[$level]{"skip"} = $skip;
		$skip = (not $file[$level]{$file[$level]{"now"}} or $file[$level]{"skip"});
	}
	elsif (/#ELSE/) {
		#warn "ELSE";
		$file[$level]{"now"} = "else";
		$skip = ((not $file[$level]{$file[$level]{"now"}}) or $file[$level]{"skip"});
	}
	elsif (/#ENDIF/) {
		#warn "ENDIF";
		$file[$level]{"now"} = "none";
		$level--;
		$skip = ((not $file[$level]{$file[$level]{"now"}}) or $file[$level]{"skip"});
	}
	elsif (/#DEFINE \$(\w+)\$ (\w+)/) {
		$vdefs{$1} = $2 unless $skip;
	}
	elsif (/#DEFINE (\w+)/) {
		$defs{$1} = 1 unless $skip;
	}
	elsif (/#UNDEF (\w+)/) {
		$defs{$1} = "" unless $skip;
	}
	elsif (not $skip) {
		if (/#INCLUDE <(.*)>/) {
			open(FILE, $1) or die "File <$1> not found!";
			my @include;
			print (@include = <FILE>);
			close(FILE);
		}
		elsif (/#INCLUDETABLE <(.+?)>( #EFR)?(?: #COND (.+))?/) {
			my $fn = $1;
			my $efr = $2;
			my $cond = $3;
			$cond = 1 if not $cond;
			#print $cond;
			#$cond = fnamerep($cond);
			my @line = "";
			my $i = 0;
			my $format = "";
			my $incllevel = 0;
			while ((($format = <INFILE>) !~ /#ENDINCLUDE/) or $incllevel > 0) {
				if ($format !~ /^\/\//) {
					$incllevel++ if $format =~ /#INCLUDETABLE/;
					$incllevel-- if $format =~ /#ENDINCLUDE/;
					chomp($format);
					$line[$i] = fnamerep($format);
					$i++;
				}
			}
			open(TABLE, $fn) or die "File <$fn> not found!";
			if ($efr) {
				my $table = <TABLE>;
			}
			my @alltable = <TABLE>;
			close(TABLE);
			tableincl(\@line, \@alltable, $cond, $efr);
		}
		else {
			print;
		}
	}
}

sub tableincl {
	my $lineref = shift;
	my @line = @{$lineref};
	my $alltableref = shift;
	my @alltable = @{$alltableref};
	my $cond = shift;
	my $efr = shift;
	my $k = 1;
	$k++ if $efr;
	my $kalt = 1;
	my $afterinclude = -1;
	foreach my $table (@alltable) {
		if ($table!~/^#/) {
			my @tl= split /[\t\r\n]/, $table;
			my $condrep = tablerep($cond, \@tl, $k, $kalt);
			if (eval($condrep)) {
				for(my $i=0; $i<=$#line; $i++) {
					my $format = $line[$i];
					if ($format =~ /#INCLUDETABLE <(.+?)>( #EFR)?(?: #COND (.+))?/) {
						my $fn = incleval(tablerep($1, \@tl, $k, $kalt));
						my $efr = $2;
						my $cond = $3;
						$cond = 1 if not $cond;
						my $j = $i+1;
						my $incllevel = 0;
						while($line[$j] !~ /#ENDINCLUDE/ or $incllevel > 0) {
							$incllevel++ if ($line[$j] =~ /#INCLUDETABLE/);
							$incllevel-- if ($line[$j] =~ /#ENDINCLUDE/);
							$j++;
						}
						open(TABLE, $fn) or die "File <$fn> not found!";
						if ($efr) {
							my $table = <TABLE>;
						}
						my @alltable = <TABLE>;
						close(TABLE);
						my @line = @line[$i+1..$j-1];
						tableincl(\@line, \@alltable, $cond, $efr);
						$i = $j;
					}
					elsif ($format =~ /#AFTERINCLUDE/) {
						$afterinclude = $i+1;
						$i = $#line;
					}
					else {
						print(incleval(tablerep($format, \@tl, $k, $kalt)),"\n");
					}
				}
				$kalt++;
			}
			$k++;
		}
	}
	if ($afterinclude != -1) {
		$k--;
		$kalt--;
		my @tl = ();
		foreach my $format (@line[$afterinclude..$#line]) {
			print(incleval(tablerep($format, \@tl, $k, $kalt)),"\n");
		}
	}
}

sub tablerep {
	my $cond = shift;
	my $sref = shift;
	my @s = @{$sref};
	my $row = shift;
	my $rowalt = shift;
	for (my $j=@s; $j>0; $j--) {
		$cond =~ s/%$j/$s[$j-1]/g;
	}
	$cond =~ s/%ROW/$row/g;
	$cond =~ s/%row/$rowalt/g;
	return $cond;
}

sub fnamerep {
	my $fn = shift;
	foreach (keys %vdefs) {
		$fn =~ s/\$$_\$/$vdefs{$_}/g;
	}
	return $fn;
}

sub incleval {
	$_ = shift;
	while (/#EVAL{(.*?)}/) {
		my $e = eval($1);
		s/#EVAL{(.*?)}/$e/;
	}
	return $_;
}